<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.yijia.label.mapper.LabelRuleMapper">
    
    <resultMap type="LabelRule" id="LabelRuleResult">
        <result property="id"    column="id"    />
        <result property="labelName"    column="label_name"    />
        <result property="stationId"    column="station_id"    />
        <result property="delFlag"    column="del_flag"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
    </resultMap>

    <sql id="selectLabelRuleVo">
        select id, label_name, station_id, del_flag, create_by, create_time, update_by, update_time
        from label_rule
    </sql>

    <select id="selectLabelRuleList" parameterType="LabelRule" resultMap="LabelRuleResult">
        <include refid="selectLabelRuleVo"/>
        <where>  
            <if test="labelName != null  and labelName != ''"> and label_name like concat('%', #{labelName}, '%')</if>
            <if test="stationId != null "> and station_id = #{stationId}</if>
            <if test="delFlag != null "> and del_flag = #{delFlag}</if>
        </where>
        order by create_time
    </select>
    
    <select id="selectLabelRuleById" parameterType="Integer" resultMap="LabelRuleResult">
        <include refid="selectLabelRuleVo"/>
        where id = #{id}
    </select>
        
    <insert id="insertLabelRule" parameterType="LabelRule" useGeneratedKeys="true" keyProperty="id">
        insert into label_rule
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="labelName != null">label_name,</if>
            <if test="stationId != null">station_id,</if>
            <if test="delFlag != null">del_flag,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="labelName != null">#{labelName},</if>
            <if test="stationId != null">#{stationId},</if>
            <if test="delFlag != null">#{delFlag},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
         </trim>
    </insert>

    <update id="updateLabelRule" parameterType="LabelRule">
        update label_rule
        <trim prefix="SET" suffixOverrides=",">
            <if test="labelName != null">label_name = #{labelName},</if>
            <if test="stationId != null">station_id = #{stationId},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteLabelRuleById" parameterType="Integer">
        delete from label_rule where id = #{id}
    </delete>

    <delete id="deleteLabelRuleByIds" parameterType="String">
        delete from label_rule where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
    
</mapper>